<script type="text/javascript">
  (async function() {
    if (!window.dimPromise) {
      const prom = {};
      prom.promise = new Promise((resolve) => (prom.resolve = resolve));
      window.dimPromise = prom;
      /* will be resolved by DimConf script */
    }

    const dim = await dimPromise.promise;
    dim.utils.genNodeTemplate("dim-cmd-client", {
      nodeName: {
        property: "name",
        label: RED._('node-red-dim/dicCmd:dicCmd.label.node-name')
      },
      nodeConf: {
        property: "cnf",
        label: RED._('node-red-dim/dicCmd:dicCmd.label.node-conf')
      },
      service: {
        property: "serviceLabel",
        label: RED._('node-red-dim/dicCmd:dicCmd.label.service')
      }
    });

    RED.nodes.registerType("dim-cmd-client", {
      category: 'network',
      color: '#F3B567',
      defaults: {
        name: { value: "" },
        cnf: { type: "dim-conf", required: true },
        serviceLabel: { value: "", required: true,
          validate: function(s) {
            if (!s) { return false; }

            const res = s.match(dic.regExp.srvDefFormat);
            if (res) {
              s = s.slice(0, res.index); /* extract service name */
            }
            this.serviceName = s; /* update service name */
            return dic.regExp.srvName.test(s);
          }
        },
        serviceName: { value: "" },
        timeout: { value: 1000 }
      },
      icon: 'bridge.svg',
      inputs: 1,
      outputs: 0,
      label: function() {
        return this.name || this.serviceLabel || "DIM CMD Client";
      },
      oneditprepare: function() {
        $("#node-input-timeout").typedInput({
          type: "num",
          types: ["num"]
        });

        const ddl = dim.utils.initDropDownList();
        if (ddl) {
          const updateDdl = async () => {
            const srvList = await dim.utils.serviceList();

            /* service list filtering */
            let filteredList = [];
            if (Array.isArray(srvList)) {
              srvList.forEach(s => {
                if (s.type === 'CMD' && s.name !== 'DIS_DNS/KILL_SERVERS') {
                  filteredList.push(s.name  + ' [ ' + s.definition + ' ]');
                }
              });
            }

            ddl.append(filteredList);
          }
          updateDdl();

          $('#node-input-cnf').one('focus', function() {
            $(this).change(function() {
              ddl.clear();
              updateDdl();
            });
          });
        }
      }
    });
  }());
</script>

<script type="text/html" data-template-name="dim-cmd-client">
  <div class="form-row">
    <label for="node-input-timeout">
      <i class="fa fa-clock-o"></i>
      <span data-i18n="dicCmd.label.timeout"></span>
    </label>
    <input type="text" id="node-input-timeout" data-i18n="[placeholder]dicCmd.default.timeout" style="width:100px;">
    <label for="node-input-timeout">
      <span data-i18n="dicCmd.label.timeout-unit"></span>
    </label>
  </div>
</script>
